(function () {
'use strict';

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

RAUL=window.RAUL||{};RAUL.plugins=RAUL.plugins||{};RAUL.plugins.maps=RAUL.plugins.maps||{};var CLUSTER_ICON_PATH='https://cdn.realpage.com/images/map/clusters/m';var DEFAULT_CLUSTER_ICONS=[{textColor:'#ffffff',url:CLUSTER_ICON_PATH+'1.png',width:'53',height:'53'},{textColor:'#ffffff',url:CLUSTER_ICON_PATH+'2.png',width:'56',height:'56'},{textColor:'#ffffff',url:CLUSTER_ICON_PATH+'3.png',width:'66',height:'66'},{textColor:'#ffffff',url:CLUSTER_ICON_PATH+'4.png',width:'78',height:'78'},{textColor:'#ffffff',url:CLUSTER_ICON_PATH+'5.png',width:'90',height:'90'}];var MARKER_ICONS={simple:{url:'https://cdn.realpage.com/images/map/pin-dot.png',scaledSize:new window.google.maps.Size(20,26),labelOrigin:new window.google.maps.Point(10,10)},withNumber:{url:'https://cdn.realpage.com/images/map/pin-number.png',scaledSize:new window.google.maps.Size(20,26),labelOrigin:new window.google.maps.Point(10,10)}/**
 * Returns Element built from markup
 */};var generateContent=function generateContent(markup){var template='\n    <div class="info-box">\n      <div class="info-box-content">\n        '+markup+'\n      </div>\n      <div class="info-box-caret"></div>\n    </div>\n  ';return new window.DOMParser().parseFromString(template,'text/html').body.firstChild;};/**
 * Returns LatLngLiteral representing content position
 */var getContentPosition=function getContentPosition(instace){var position=instace.getProjection().fromLatLngToDivPixel(instace.latlng);var contentStyle=window.getComputedStyle(instace.content);var contentHeight=parseFloat(contentStyle.height);var contentWidth=parseFloat(contentStyle.width);var markerOffsetY=instace.markerSize.height+contentHeight+INFO_BOX_CARET_HEIGHT_OFFSET;var markerOffsetX=contentWidth/2;return{left:position.x-markerOffsetX,top:position.y-markerOffsetY};};var INFO_BOX_CARET_HEIGHT_OFFSET=10;/**
 * Represents an Info Box (a custom version of InfoWindow using OverlayView).
 * @extends google.maps.OverlayView
 */var InfoBox=function(_window$google$maps$O){inherits(InfoBox,_window$google$maps$O);function InfoBox(map,marker){var content=arguments.length>2&&arguments[2]!==undefined?arguments[2]:'';classCallCheck(this,InfoBox);var _this=possibleConstructorReturn(this,(InfoBox.__proto__||Object.getPrototypeOf(InfoBox)).call(this));_this.mapReference=map;_this.marker=marker;_this.markerIcon=_this.marker.getIcon();_this.latlng=_this.marker.getPosition();_this.content=generateContent(content);_this.markerSize=_this.markerIcon.size||_this.markerIcon.scaledSize;_this.content.__infoBox__=_this;window.google.maps.event.addDomListener(_this.content,'click',function(event){event.stopPropagation();window.google.maps.event.trigger(_this,'click');});window.google.maps.event.addListener(_this.marker,'click',function(){[].concat(toConsumableArray(document.querySelectorAll('.info-box'))).forEach(function(infoBox){return infoBox.__infoBox__.close();});_this.open();});window.google.maps.event.addListener(map,'click',function(event){return _this.close();});return _this;}/**
   * Extension metho to help generate InfoBox directly from marker
   * @param {google.maps.Marker} marker - an instance of a google maps Marker
   */createClass(InfoBox,[{key:'open',/**
   * Opens the InfoBox instance
   */value:function open(){this.setMap(this.mapReference);}/**
   * A required method implementation of OverlayView
   */},{key:'draw',value:function draw(){var position=getContentPosition(this);this.content.style.left=position.left+'px';this.content.style.top=position.top+'px';}/**
   * A required method implementation of OverlayView
   */},{key:'onAdd',value:function onAdd(){this.getPanes().floatPane.appendChild(this.content);this.content.style.display='block';}/**
   * A required method implementation of OverlayView
   */},{key:'onRemove',value:function onRemove(){this.content.style.display='none';}/**
   * Closes the InfoBox instance
   */},{key:'close',value:function close(){this.setMap(null);}}],[{key:'fromMarker',value:function fromMarker(marker){return new this(marker.map,marker,marker.info);}}]);return InfoBox;}(window.google.maps.OverlayView);RAUL.plugins.maps.google={InfoBox:InfoBox,/**
   * Determines center point of markers. Returns Lat/Lng object literal.
   * @param {Array<LatLng|Lat/Lng object literal>} locations - Array of LatLng objects or literals.
   */averageLatLng:function averageLatLng(locations){var average=function average(arr){return arr.reduce(function(left,right){return left+right;})/arr.length;};return{lat:average(locations.map(function(location){return location.lat;})),lng:average(locations.map(function(location){return location.lng;}))};},/**
   * Creates a new google map marker instance
   * @param {Object} map - The map object instance.
   * @param {string || null} [label = null] - The marker label number.
   * @param {number} lat - The latitude coordinate.
   * @param {number} lng - The longitude coordinate.
   * @param {string} [info = null] - The marker info window text.
   * @param {number} [zIndex = null] - The z-index of the marker.
   */createMarker:function createMarker(_ref){var map=_ref.map,_ref$label=_ref.label,label=_ref$label===undefined?null:_ref$label,lat=_ref.lat,lng=_ref.lng,_ref$info=_ref.info,info=_ref$info===undefined?null:_ref$info,_ref$zIndex=_ref.zIndex,zIndex=_ref$zIndex===undefined?null:_ref$zIndex;return new window.google.maps.Marker({icon:label?MARKER_ICONS.withNumber:MARKER_ICONS.simple,info:info,label:label?{text:label,color:'#ffffff',fontSize:'0.65rem'}:null,map:map,position:new window.google.maps.LatLng(lat,lng),zIndex:zIndex});},/**
   * Creates a new google map marker clusterer instance
   * @param {Object} map - The map object instance.
   * @param {Array} markers - Markers array.
   * @param {Object} options - Marker clusterer options.
   */createMarkerClusterer:function createMarkerClusterer(_ref2){var map=_ref2.map,markers=_ref2.markers,_ref2$options=_ref2.options,options=_ref2$options===undefined?{}:_ref2$options;var opts=_extends({styles:DEFAULT_CLUSTER_ICONS},options);return new window.MarkerClusterer(map,markers,opts);}};

}());
